"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariant(ProtocolElement):
    """
    A reported variant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alleleOrigins",
        "reportEvents",
        "variantCalls",
        "variantCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "alleleFrequencies": reports_5_0_0.AlleleFrequency,
            "reportEvents": reports_5_0_0.ReportEvent,
            "variantAttributes": reports_5_0_0.VariantAttributes,
            "variantCalls": reports_5_0_0.VariantCall,
            "variantCoordinates": reports_5_0_0.VariantCoordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "alleleOrigins": reports_5_0_0.AlleleOrigin,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.AlleleFrequency": reports_5_0_0.AlleleFrequency,
            "org.gel.models.report.avro.AlleleOrigin": reports_5_0_0.AlleleOrigin,
            "org.gel.models.report.avro.ReportEvent": reports_5_0_0.ReportEvent,
            "org.gel.models.report.avro.VariantAttributes": reports_5_0_0.VariantAttributes,
            "org.gel.models.report.avro.VariantCall": reports_5_0_0.VariantCall,
            "org.gel.models.report.avro.VariantCoordinates": reports_5_0_0.VariantCoordinates,
            "org.gel.models.report.avro.ReportedVariant": reports_5_0_0.ReportedVariant,
        }

    __slots__ = [
        "alleleOrigins",
        "reportEvents",
        "variantCalls",
        "variantCoordinates",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "alleleFrequencies",
        "cdnaChanges",
        "clinVarIds",
        "comments",
        "cosmicIds",
        "dbSnpId",
        "genomicChanges",
        "proteinChanges",
        "references",
        "variantAttributes",
    ]

    def __init__(
        self,
        alleleOrigins,
        reportEvents,
        variantCalls,
        variantCoordinates,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        alleleFrequencies=None,
        cdnaChanges=None,
        clinVarIds=None,
        comments=None,
        cosmicIds=None,
        dbSnpId=None,
        genomicChanges=None,
        proteinChanges=None,
        references=None,
        variantAttributes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.ReportedVariant model.

        :param alleleOrigins:
            List of allele origins for this variant in this report
        :type alleleOrigins: list[AlleleOrigin]
        :param reportEvents:
            The list of report events for this variant across multiple modes of
            inheritance and panels
        :type reportEvents: list[ReportEvent]
        :param variantCalls:
            List of variant calls across all samples under analysis for this
            variant
        :type variantCalls: list[VariantCall]
        :param variantCoordinates:
            The variant coordinates. Chromosome is either 1-22, X, Y, MT or any
            other contif in the reference genome,         no "chr"
            prefix is expected. Position is 1- based. Reference and
            alternate should never be empty or any         character
            representing emptiness (e.g.: . or -), a VCF-like indel
            representation is expected.
        :type variantCoordinates: VariantCoordinates
        :param additionalNumericVariantAnnotations:
            Additional numeric variant annotations for this variant. For Example
            (Allele Frequency, sift, polyphen,         mutationTaster,
            CADD. ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            Any additional information in a free text field. For example a quote
            from a paper
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param alleleFrequencies:
            A list of population allele frequencies
        :type alleleFrequencies: None | list[AlleleFrequency]
        :param cdnaChanges:
            cDNA change, HGVS nomenclature (e.g.: c.76A>T)
        :type cdnaChanges: None | list[str]
        :param clinVarIds:
            Variant identifier in ClinVar
        :type clinVarIds: None | list[str]
        :param comments:
            Comments
        :type comments: None | list[str]
        :param cosmicIds:
            Variant identifier in Cosmic
        :type cosmicIds: None | list[str]
        :param dbSnpId:
            Variant identifier in dbSNP
        :type dbSnpId: None | str
        :param genomicChanges:
            gDNA change, HGVS nomenclature (e.g.: g.476A>T)
        :type genomicChanges: None | list[str]
        :param proteinChanges:
            Protein change, HGVS nomenclature (e.g.: p.Lys76Asn)
        :type proteinChanges: None | list[str]
        :param references:
            Additional references for ths variant. For example HGMD ID or Pubmed
            Id
        :type references: None | dict[str, str]
        :param variantAttributes:
            Additional variant attributes
        :type variantAttributes: None | VariantAttributes
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
